/*
 * Progetto 3 del Capitolo 6 del libro Savitch.
 * 
 * Un palindromo  una parola o una frase che non cambia se
 * letta da sinistra a destra o viceversa, ignorando gli 
 * spazi e senza distinguere fra lettere maiuscole e minuscole.
 * Per esempio, le seguenti frasi e parole sono palindrome:
 * 
 * a. Ai lati d'Italia
 * b. radar
 * c. I topi non avevano nipoti
 * d. xyzczyx
 * 
 * Scrivere un programma che accetta una sequenza di caratteri 
 * terminata da un punto e decide se tale stringa (escluso il
 * punto)  palindroma. Si supponga che l'input contenga solo
 * caratteri e spazi e sia al pi lungo 80 caratteri. 
 * Includere un ciclo che consenta all'utente di controllare 
 * pi stringhe.
 * Suggerimento: definire un metodo statico chiamato
 * palindroma che inizi come segue:
 * 
 * Precondizione: L'array contiene lettere e spazi nelle
 * posizioni da a[0] fino a a[utilizzato-1].
 * Restituisce true se la stringa  palindroma 
 * e false altrimenti.
 * 
 * public static boolean palindroma(char[] a, int utilizzato)
 * 
 * Il programma deve leggere i caratteri in input e inserirli
 * in un array il cui tipo base  char e in seguito chiamare
 * questo metodo. La variabile int utilizzato tiene traccia di
 * quanta parte dell'array  utilizzata, come descritto nel
 * paragrafo "Array parzialmente riempiti".
 */

import java.util.*;

public class FrasePalindroma {
	
	public static final int MAX_CARATTERI = 80;
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		boolean finito = false;
		do{
			System.out.println("Inserire la frase: ");
			String frase = tastiera.nextLine();
			char[] fraseSenzaSpazi = new char[MAX_CARATTERI];
			int lettereInserite=0;
			for(int i=0; i<frase.length();i++){
				/* eventualmente escludere anche altri caratteri speciali */
				if(frase.charAt(i)!=' '&& frase.charAt(i)!='.'&& frase.charAt(i)!='\'') 
					fraseSenzaSpazi[lettereInserite++]=frase.charAt(i);
			}
					
			if(palindroma(fraseSenzaSpazi, lettereInserite))
				System.out.println("La frase  palindroma");
			else
				System.out.println("La frase non  palindroma");
			System.out.print("Vuoi continuare (s/n)? ");
			String risposta = tastiera.next();
			if(risposta.equalsIgnoreCase("n"))
				finito=true;
			else
				tastiera.nextLine();
		}while(!finito);
	
		tastiera.close();
	}
	
	public static boolean palindroma(char[] a, int utilizzato){
		boolean uguale=true;
		int i=0;
		while(i<utilizzato/2 && uguale){
			if(a[i]!=a[utilizzato-1-i])
				uguale=false;
			i++;
		}
		return uguale;
	}

}
